=begin
(c) TIG 2011
Permission to use, copy, modify, and distribute this software for 
any purpose and without fee is hereby granted, provided the above
copyright notice appear in all copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
File:
Put the file Rotateplanview.rb in the Plugins folder.***
Usage:
To use set up your Plan [Top] view, without Perspective and 
in the Ruby Console type Rotateplanview.new to rotate the camera 45 degrees 
clockwise, repeat to rotate it another 45 degrees etc. 
The extents are zoomed after each rotation.
To do other angles provide an angle value in degrees - 
e.g. Rotateplanview.new 10 rotates the view 10 degrees clockwise or 
Rotateplanview.new -30 rotates the view 30 degrees counterclockwise.
When you are happy with it save the view to a new Scene tab so you can 
return to it later.
Note: v1.1 includes a View Menu > 'Rotate Plan View' item and there is 
also a 'Rotate Plan View' toolbar that can be activated from the 
View > Toolbar menu, ***this needs the icon Rotateplanview.png in the 
../Plugins/TIGtools subfolder.
If you use one of these tools this way you will get a dialog asking for 
the angle, the default is +45 degrees. otherwise it works as above...
Donations:
by PayPal to info @ revitrev.org
Version:
1.0 20110304 First issue.
1.1 20110316 Menu/Dialog/Toolbar item added.
=end
###
require 'sketchup.rb'
###
class Rotateplanview
 @@angle=nil
 def initialize(angle=45.0)
  model=Sketchup.active_model
  view=model.active_view
  camera=view.camera
  up=camera.up
  return if up==Z_AXIS
  eye=camera.eye
  target=camera.target
  persp=false
  tr=Geom::Transformation.rotation(target, Z_AXIS, angle.degrees)
  up.transform!(tr)
  newcamera=Sketchup::Camera.new(eye, target, up, persp)
  view.camera=newcamera
  Sketchup.send_action("viewZoomExtents:")
 end
 def Rotateplanview::dialog()
   @@angle=45.0 if not @@angle
   prompt="旋转角度 +（顺时针）/-（逆时针） : "
   title="视图旋转"
   result=UI.inputbox([prompt], [@@angle], title)
   return nil if not result
   @@angle=result[0]
   return nil if @@angle==0.0
   Rotateplanview.new(@@angle)
 end
end#class
###
if not file_loaded?(File.basename(__FILE__))
  ### deBabelized
  text0 = "视图旋转"
  text1 = "视图旋转..."
  text2 = "根据驶入的角度视图旋转..."
  cmd=UI::Command.new(text1){Rotateplanview.dialog()}
  cmd.tooltip=(text1)
  cmd.status_bar_text=(text2)
  ### menu
  UI.menu("View").add_item(cmd)
  ### toolbar only if ison found...
  if File.exists?(File.join(File.dirname(__FILE__),"TIGtools","Rotateplanview.png"))
    cmd.small_icon=File.join(File.dirname(__FILE__),"TIGtools","Rotateplanview.png")
    cmd.large_icon=File.join(File.dirname(__FILE__),"TIGtools","Rotateplanview.png")
    toolbar=UI::Toolbar.new(text0)
    toolbar.add_item(cmd)
    toolbar.restore if toolbar.get_last_state==TB_VISIBLE
  end#if
  ###
end#if
file_loaded(File.basename(__FILE__))
###
